<?php
/**
* Konfiguracja systemowa sklepu.
*
* UWAGA! Plik tem moe by edytowany tylko przez progamistw, ktrzy dokadnie wiedz co zmieniaj. Nie jest to
* plik konfiguracji sklepu dla uzytkownikw sklepu.
*
* Wiele wartoci zdefiniowanych i opisach w klasie Config,
* jest nadpisywana przez inne pliki konfiguracyjne np. plik tworzony z definicjami w wprowadzanymi w panelu
* config/auto_config/user_config.inc.php, dlatego te zmiana wartoci nie zawsze spodowuje to, czego oczekujemy.
* Jeli chcemy wprowadza zmiany to naley dokadnie przeledzi ca drog generowania danych dla obiektu
* $config.
*
* @author  m@sote.pl lech@sote.pl
* @version $Id: config.inc.php,v 2.58 2004/10/27 11:15:10 maroslaw Exp $
* @package config
* @subpackage base
*
* $Log: config.inc.php,v $
* Revision 2.58  2004/10/27 11:15:10  maroslaw
* ""
*
* Revision 2.55  2004/10/27 08:13:49  maroslaw
* Dodanie Log
*
*/

/**
* Gwna klasa konfiguracji sklepu.
* @package config
* @subpackage base
*/
class Config {
    
    /**
    * Wersja SOTEeSKLEP. Seria.
    */
    var $version="3.x";
    
    /**
    * devel=1, wersje debveloperska sklepu.
    * @ignore
    * @todo dodac obsug trybu dla developerw
    */
    var $devel=1;
    
    /**
    * Rodzaj bazy danych; obecnie tylko mysql.
    */
    var $dbtype="mysql";
    
    /**
    * Nazwa bazy danych. Pod t zmienn zostan podstawione odszyfrowane dane dot. bazy danych.
    */
    var $dbname;
    
    /**
    * Nazwa uytkownika dostpu do bazy danych.
    */
    var $dbuser;
    
    /**
    * Haso dostpu do bazy danych.
    */
    var $dbpass;
    
    /**
    * Serwer bazy danych.
    */
    var $dbhost;
    
    /**
    * Okrelenie czy dana wersja jest demonstracyjn?: yes - wersja demo, no - wersja produkcyjna
    * Jeli demo jest wczone to panel sklepu jest tylko w trybie do odczytu.
    * @todo zmieni? "yes"=>1, "no"=>0
    */
    var $demo="no";
    
    /**
    * Okrelenie poziomu logowania. 1 - logowanie wczone, 0 - wyaczone
    */
    var $logs=1;                         // poziom logowania
    
    /**
    * Okre?lenie trybu parcy sklepu.
    * Jeli cd=1 to wyczane s niektre funkcje, dziki czemu sklep atwiej jest zgra na CD.
    * Opcja ta jest przeczana z panelu.
    */
    var $cd=0;
    
    /* @deprecated since 3.0 */
    var $simple="no";
    
    /**
    * Prefix URL do htdocs dla SV
    * @deprecated since 3.0
    */
    var $htdocs_dir="";
    
    /**
    * Prefix URL do admin dla SV
    * @deprecated since 3.0
    */
    var $admin_dir="";
    
    /**
    * prefix URL = htdocs_dir lub admin_dir
    * @deprecated since 3.0
    */
    var $url_prefix="";
    // end sv:
    
    /**
    * Adres internetowy sklepu. Zmienna konfigurowana z panelu.
    */
    var $www;
    
    /**
    * @var int category_multi 1 - wcz opcj: 1 produkt w kilku kategoriach, 0 - w p.w.
    */
    var $category_multi=1;
    
    /**
    * @var int Zmienna odpowiedzialna za wywietlenie w sklepie listy walut do wyboru. 
    */
   
    var $currency_show_form=1; 
    
    /**
    * Jzyk w ktrym bdzie domylnie pracowa sklep. Aktualna warto jezyka, w ktrym pracuje sklep.
    * Po zmianie jzyka jest modyfikaowana ta zmienna.
    */
    var $lang="pl";

    /**
    * Domylny jzyk w sklepie (nie w panelu). Zmienna ta ma t sam warto co $config->lang.
    * Jest ona wykorzystywana w panlu do sprawdzenia jzyka zdefiniowanego dla sklepu, gdy
    * w panelu zmienna $config->lang ma warto aktualnie wywietlanego jzyka dla panelu, co 
    * nie musi sie zgadza z ustawieniami dla sklepu.
    */
    var $htdocs_lang="pl";
    
    /**
    * Bazowy jzyk sklepu. Wedug tego jezyka s przypisywane gwne wartoci $lang, nastpnie
    * odczytywane s wartoci dla jzyka $config->lang, ktre nadpisuj wczeniejsze definicje.
    */
    var $base_lang="pl";
    
    /**
    * Jzyk w ktrym bdzie domylnie pracowa panel administracyjny sklepu.
    */
    var $admin_lang="pl";
    
    /**
    * Dostpne jzyki w sklepie. Oznaczenia.
    */
    var $languages=array("pl","en","de");   
    /**
    * Nazwy jzykw wg oznacze?.
    */
    var $languages_names=array
    (
    "pl"=>"Polski",
    "en"=>"English",
    "de"=>"Deutsch",   
    );
   
    
    var $lang_active=array("pl"=>1,
                           "en"=>1,
                           "de"=>1,
                                                  
    );
    
    /**
    * @var array Zmienna odpowiedzialna za przypisanie odpowiedniej waluty odpowiediej wersji jzykowej. 
    */
      
    var $currency_lang_default=array("polski"=>1); 
     
    // start tematy wygldu sklepu:
    /**
    * Nazwa tematu bazowego
    */
    var $base_theme="base_theme";
    
    /**
    * Nazwa tematu kocowego(tematu  wygldu).
    * temat okrela katalog, w ktrym bd wyszukiwane odpowiednie pliki/szablony prezentacji itp.
    */
    var $theme="blue";
    
    /**
    * Lista dotpnych tematow wygldu sklepu
    */
    var $themes=array
    (
    "redball"=>"redball",
    "blueball"=>"blueball",
    "red"=>"red",
    "blue"=>"blue",
    "green"=>"green",
    "brown"=>"brown",
    "blueday"=>"blueday",
    "grayday"=>"grayday",
    "bluelight"=>"bluelight",
    "pinklight"=>"pinklight",
    );
    // end tematy wygl?du sklepu:
    
    // start tematy wygladu panelu administratora:
    /**
    * Nazwa bazowego tematu w panelu amdinistracyjnym.
    */
    var $admin_base_theme="base_theme";
    
    /**
    * Nazwa tematu kocowego w panelu amdinistracyjnym.
    */
    var $admin_theme="base_theme";
    
    /**
    * Lista dotpnych tematw wygladu panelu administracyjnego.
    */
    var $admin_themes=array
    (
    "base_theme"=>"standard",
    "green"=>"jungle",
    "box"=>"box",
    );
    // end tematy wygladu panelu administratora:
    
    /**
    * Okrelenie czy dla sklepu dostpna jest obsuga SSL.
    */
    var $ssl="no";
    
    /**
    * @var string Domylna waluta, w ktrej bda prezentowane i zapisywane ceny.
    *             Jest to waluta rozliczenia.
    */
    var $currency="PLN";
    
    /**
    * Konto, na ktre s wysylane zamwienia.
    */
    var $order_email='';
    
    /**
    * Od kogo bd wysyane wiadomoci z zamwieniem.
    */
    var $from_email='';
    
    /**
    * Dane sprzedawcy - edytowane z panelu.
    */
    var $merchant=array();
                                     
    /**
    * @var array lista edytowalnych tematow wygladu sklepu   
    */
    var $editable_themes=array(
                        "blue"=>"blue",
                        "redball"=>"redball",
                        "blueday"=>"blueday",
                        "grayday"=>"grayday",
                        "bluelight"=>"bluelight",
                        "pinklight"=>"pinklight",
                      );     
    
    /**
    * Maksymalna wielko?? uploadowanego pliku w bajtach: 1000000=1MB
    */
    var $max_file_size=1000000;

    
    // start FTP:
    // dane konta ftp, na ktorym jest zainstalowany program
    var $ftp_dir='';
    var $ftp_password=-1;                // UWAGA! nie wpisywac tu hasla!
    var $ftp_port="21";
    // end FTP:
    
    /**
    * Dodatkowy klucz wykorzystywany do kodowania.
    * Po zainstalowaniu sklepu NIE WOLNO zmienia tej wartoci.
    */
    var $salt='12345678901234567890123456789012';
    
    /**
    * Adres servleta eCard
    * @deprecated since 3.0
    */
    var $ecard_servlet="http://adres_servleta_ecardu";
    // Ujednolicenie kolorw elementach sklepu
    var $colors=array("light"=>"#E9F0F8",
    "dark"=>"#6699cc",
    );
    
    /**
    * Opcja okrela, czy w sklepie mona docza zdcia do zamwionych produktw np. zdjcie na nadruki na koszulki.
    * /go/_basket/_photo zalaczanie zdjec do produktow
    */
    var $basket_photo="no";
    
    /**
    * Czy zdjcia robione sa aparatem cyfrowym? Jesli tak to nadawaj automatycznie nazwy zdjeciom wg. id
    */
    var $cyfra_photo=1;
    
    /**
    * Typ ceny jaki si ma wyswietla: netto, brutto, netto/brutto
    */
    var $price_type="netto/brutto";
    
    /**
    * Iloc produktw na listach w zalenoci od typu listy.
    * "short" - lista uproszczona bez zdjec i opisu, "long" - pelna lista ze zdjeciami i krotkim opisem
    */
    var $products_on_page=array
    (
    "short"=>20,
    "long"=>10
    );
    
    /* Domylny rodzaj listy proudktow "short", "long" jw. */
    var $record_row_type_default="long";
    
    var $vat_confirm=1;
        
    /**
    * Rozmiary duych i maych zdj na listach i w informacjach szczegoowych produktw.
    */
    var $image=array
    (
    "max_size" =>"300",
    "min_size" =>"115",
    );
    
    /**
    * Od jakiego numeru numerowa transakcje, domylne id startowe transakcji
    */
    
    var $id_start_orders_default=1;
    
    /**
    * Okrelenie czy wstawiamy okienko newsletter na stronie
    */
    var $newsletter=1;
    
    /**
    * Okrelenie czy wstawiamy newsedit na gwnej stronie sklepu
    */
    
    var $newsedit=0;
    
    /**
    * Newsedit w kolumnach jednej czy dwoch
    */
    
    var $newsedit_columns_default=1;
    
    /**
    * Dpmylna ilo produktw kolumnach promocje,nowosci itd
    */
    var $random_on_page=array("promotion"=>2,
                              "newcol"=>3,
                              "bestseller"=>2,
                         );
    
    /**
    * Domylny rodzaj sortowania produktw na listach.
    */
    var $main_order_default="name";
    
    /**
    * Pola, ktore musz byc zaselectowane do odczytania nazwy produktu, producenta i ceny
    */
    var $select_main_price_list="id,user_id,name,en_name,de_name,producer,price_brutto,vat,price_brutto_detal,photo,price_brutto_2,hidden_price,ask4price,discount,price_currency,id_currency,id_category1,id_category2,id_category3,id_category4,id_category5,id_producer";
    
    
    /**
    * Metody patnoci dost?pne w sklepie.
    * UWAGA! Nie mona zmienia ID.
    */
    var $pay_method=array
    (
    "1"=>"Za zaliczeniem",
    // "2"=>"eCard",
    "3"=>"PolCard",
    // "4"=>"Inteligo",
    // "5"=>"mBank",
    // "6"=>"CitiConnect",
    // "7"=>"PayU",
    // "8"=>"WBK",
    // "9"=>"SMS",
    "11"=>"Przelew",
    // "12"=>"Przelewy24",
    );
    
    /**
    *Aktywacja wybranej metody platnosci
    */    
    var $pay_method_active=array
    (
    "1"=>1,
    "11"=>1
    );


    
    /**
    * Rodzaj prezentacji kategorii
    * "treeview" - dynamiczne JS+DHTML, "standard" - statyczne z przeladowaniem strony
    */
    var $category=array
    (
    "type"=>"standard",
    );
    
    /**
    * Przegladarki, ktore nie obsuguj javascript wymaganego dla Treeview.
    *
    * zachowana dla zgodno?ci
    * @deprecated since 3.0
    */
    var $browsers_nojavascript=array();
    // var $browsers_nojavascript=array("Mozilla/4","konqueror","safari");

   /**
    * Dostepno. Tablica ID->nazwa.
    * Warto tablicy jest definiowana dynamicznie w ./auto_config/user_config.inc.php
    */
    var $availabale=array();
    
    /**
    * @var array tablica ze zmiennymi, ktore sa zpisywane przez uzytkwonika w ./auto_config/user_config.inc.php
    */
    var $user_vars=array("db","ftp","salt","md5_pin","license","auth_sign","config_setup",
    "order_points","available","currency_data","currency_name",
    "category","stats","merchant","order_email","from_email","newsletter_email",
    "www","currency","cd_setup","theme","themes_active",
    "record_row_type_default","producers_category_filter","google",
    "price_type","currency","products_on_page","google","image",   
    "main_order_default","vat_confirm","id_start_orders_default","newsedit_columns_default",
    "lang","lang_active","currency_lang_default",
    "category_multi","newsedit","newsletter","currency_show_form","cyfra_photo",
    "basket_photo","htdocs_lang","pay_method_active","random_on_page","themes","theme","fields",
    "editable_themes","admin_lang","home",
    );
    
    var $themes_active=array();
    
    var $in_category_down=3;     // [1-5] ilosc porownywanych kategorii przy liscie produktow z tej samej kategorii
    // czy promocje, nowosci oraz wyszukiwanie maja zalezec od wybranego producenta?
    var $producers_category_filter="yes";
    // wprowadz id producenta i odpowiedni dla niego temat
    var $themes_producers=array("12"=>"art_orange");
    // wprowadz id kategorii i odpowieni temat dla danej kategorii np. 18, 18_1, 18_1_4 itp.
    var $themes_category=array("18"=>"art_orange");
    // end plugins
    
    /**
    * Ocena ryzyka transakcji  @depend  $lang->pay_fraud
    * true - nie wyswietlaj ostrzezenia, false - wyswietl ostrzezenie przy transakcji
    * wartosc <0 oznacza inne zagrozenia, ktore nalezy zglosic pilnie do amdinistratora
    */
    var $pay_fraud=array
    (
    "1"=>-1,
    "2"=>-1,
    "10"=>-1,
    "300"=>true,
    "301"=>true,
    "302"=>false,
    "303"=>false
    );
    
    /**
    * Ilosc dni przed koncem terminu rozliczenia transakcji, kiedy system ostrzega sprzedawce o koniecznosci potwierdzenia transakcji
    */
    var $order_alert_days=3;
    
    /**
    * Ilo dni, po ktorych transakcja nie bedzie przyjeta wg. id_pay_method
    */
    var $order_timeout=array("2"=>7,
    "3"=>7,
    "4"=>30
    );
    
    /**
    * Okrelenie kolumn sortowania wg parametru $order - dla tablicy main
    */
    var $dbedit_order_names=array('main'=>array
    (
    "1"=>"name",
    "-1"=>"name DESC",
    "2"=>"price_brutto",
    "-2"=>"price_brutto DESC",
    "3"=>"producer",
    "-3"=>"producer DESC",
    "default"=>"price_brutto"
    )
    );
    
    /**
    * Domylna konfiguracja nazwy, tytuu strony itp.
    */
    var $google=array("title"=>"SOTEeSKLEP",
    "keywords"=>"sklep internetowy",
    "description"=>"sklep internetowy");
    
    /**
    * Okresl katalog "tematu"
    *
    * @return string katalog np. /home/www/webapps/htdocs/themes/_pl/standard
    */
    function theme_dir(){
        global $_SERVER;
        $this->theme_dir=$_SERVER['DOCUMENT_ROOT']."/themes/_".$this->lang."/".$this->theme;
        return $this->theme_dir;
    } // end theme_dir()
    
} // end class Config

// ------------------------------ koniec konfiguracji----------------------------------------

// odczytaj konfiguracje wygenerowana automatycznie i utworz obiekt $config
require_once("config/auto_config/config.inc.php");


// odczytaj konfiguracje uzytkownika (ustawiane przez panel on-line)
require_once("config/auto_config/user_config.inc.php");


// odczytaj dane licencji
$lckey=substr($config->license['nr'],12,2);
switch ($lckey) {
    case "01": $__nccp="0x1388";  break;
    case "11": $__nccp="0x1388";  break;
    case "02": $__nccp="0x01f4";  break;
    default: $__nccp="0x01f4"; break;
}
// end

// odczytaj konfiguracje nccp
require_once ("config/auto_config/nccp_config.inc.php");


if (empty($config)) {
    $config =& new Config;
}

if (!in_array("multi_lang",$config->plugins)) {
	$config->lang="pl";
	$config->languages=array("pl");
  	$config->languages_names=array("pl"=>"Polski");
}

$config->theme_dir();

/**
* Ustaw odpowiedni jezyk dla panelu
*/
if ($shop->admin) {
    $config->lang=$config->admin_lang;
}

// sprawdz czy jest zdefiniowany indywidualny klucz aplikacji
$secure_key=ini_get("disable_function");
if ((! empty($secure_key)) && (eregi("^[0-9a-z]${32}"))) {
    $config->salt=$secure_key;
}

// wlacz demo tylko w panelu demo
if (ereg("htdocs$",$DOCUMENT_ROOT)) {
    $config->demo="no";
}

// sprawdz przegladarke i jesli przegladarka nie obsluguje javascript (tj. treeview) to wlacz statyczne menu
foreach ($config->browsers_nojavascript as $browser) {
    if (eregi($browser,$_SERVER['HTTP_USER_AGENT'])) {
        $config->category['type']="standard";
    }
} // end foreach

// start cd:
if ((in_array("cd",$config->plugins)) && (@$config->cd_setup['cd']==1) && ($_SERVER['REMOTE_ADDR']==@$config->cd_setup['IP']) && ($shop->admin==0))  {
    $config->cd=1;
    $config->lang_active=array();         // dezaktywuj linki do roznych wersji jezykowych
    $config->category['type']="standard"; // wlacz statyczne kategorie
    // sprawdz jakie ceny maj by wywietlane
    if ($config->cd_setup['price']=="netto") {
        $config->price_type="netto";
    }
} else $config->cd=0;
// end cd:

if (!in_array("extbasket",$config->plugins)) {
	$config->basket_photo=0;
}

// UWAGA! po zamknieciu PHP nie moze byc zadnych znakow! inaczej pojawi sie warning przed
// otwarciem sesji
?>