<?php
/**
* Obsluga atrybutow do produktow, typ "multi"
* Zmiana atrybutu, ceny, zdjecia, prezenatcja atrybutow
*
* @author  m@sote.pl lech@sote.pl
* @version $Id: multi_group.inc,v 2.19 2004/10/26 13:35:25 maroslaw Exp $
* @package soteesklep
*/

require_once ("HTML/Form.php");
require_once ("include/price.inc");
require_once("include/lang_functions.inc");

define ('ATTR_MAX_NUM',10);            // maksymalna ilosc atrybutow
define ('ATTR_MAX_ELEMENTS_NUM',5000); // maksymalna ilosc opcji danego atrybutu
define ('ATTR_MAX_CAT_LIST',100);      // maksymalna ilosc produktow z kategorii na liscie
define ('ATTR_MAX_OPTIONS',3);         // maksymalna liczba opcji przy danej opcji np. nazwa, cena, zdjecie

class MultiGroup {
    /**
    * @var bool zmianna okreslajaca czy wyswietlana bedzie lista z obsluga zmiany zdjecia
    */
    var $_allow_change_image=true;
    
    /**
    * @var bool zmienna okreslajaca, czy w danej liscie zostala wywolana zmiana zdjecia
    */
    var $_change_image=false;
    
    /**
    * @var float $price_brutto  wartosc zakupu wg atrybutow
    */
    var $_price_brutto=0;
    
    /**
    * @var bool $_set_price informacja o tym, czy w formularzyu jest opcja zmiany ceny
    */
    var $_set_price=false;
    
    /**
    * Tablica powiazan nazwa opcji => nazwa elementu formularza np. Rozmiar=>"attr2"
    */
    var $_names=array();        
        
    /**
    * Konstruktor
    */
    function MultiGroup () {
        global $rec,$config,$shop;
        
        if ($shop->admin) $action='#';
        else $action=$config->url_prefix."/go/_basket/index.php";
        $this->forms = new HTML_Form($action,"POST","attrib");
        
        $this->forms->addHidden("id",@$rec->data['id']);
        $this->my_price = new MyPrice;
        
        return(0);
    } // end MultiGroup
    
    /**
    * @var array grupy atrybutow
    */
    var $_groups=array();
    
    var $_num=1; // numer porzadkowy atrybutu
    
    /**
    * Wyswietl prezentacje atrybutow do produktu
    *
    * @param &$result wynik zapytania z bazy danych
    *
    * @access public
    * @return none
    */
    function show(&$result) {
        global $db,$config,$lang;
        
        include_once ("lib/JavaScripts/imgChange.js");
        include_once ("lib/JavaScripts/selectChange.js");
        $this->_SelectGroups($db->FetchResult($result,0,'xml_options'));
        $this->forms->addSubmit('add2basket',$lang->info_attrib_order);
        // element, pod ktorym beda (przez skrypt JS) zapisane dostepne wartosci 
        // pola dla modyfikowanego pola select
        $this->forms->addHidden('attr_memory','null'); 
        $this->_showForm();
        
        return (0);
    } // end show()
    
    /**
    * Podziel dane na grupy oddzielone pusta linia
    *
    * @param string &$xml_options wartosc pola xml_options
    * @global array $this->_groups
    *
    * @access private
    * @return none
    */
    function _SelectGroups(&$xml_options) {
        $this->_groups=preg_split("/\n\s/",$xml_options,ATTR_MAX_NUM,PREG_SPLIT_NO_EMPTY);
        reset($this->_groups);
        foreach ($this->_groups as $group) {
            
            if (trim($group)!='multi') {
                $group_tab=preg_split("/\n/",$group,ATTR_MAX_ELEMENTS_NUM,PREG_SPLIT_NO_EMPTY);
                if (eregi("^ID:",@$group_tab[1])) {
                    $this->_checkbox($group_tab);
                } elseif (eregi("^IDC:",@$group_tab[1])) {
                    $this->_select_cat($group_tab);
                } else {
                    $this->_select($group_tab);
                }
            }
            
        } // end foreach
        return(0);
    } // end _SelectGroups()
    
    /**
    * Wyswietl formularz z atrybutami
    *
    * @access private
    * @return none
    */
    function _showForm() {
        $this->forms->display();
        return (0);
    } // end _showForm()
    
    /**
    * Przetumaczenie atrybutw na biec wersj jzykow
    * 
    * @param array $data tablica z danymi [0]->nazwa pola [1]..[n]->atrybuty
    * @access private
    * @return array Przetumaczona tablica atrybutw
    * @author lech@sote.pl
    */
    function _translateData($data) {
        while(list($key, $val) = each($data)) {
            $val_arr = explode(',', $val);
            $val_arr[0] = LangF::translate(trim($val_arr[0]));
            $data[$key] = implode(', ', $val_arr);
        }
        return $data;
    }

    /**
    * Wyswietl element select z atrybutami
    *
    * @param array $data tablica z danymi [0]->nazwa pola [1]..[n]->atrybuty
    *
    * @access private
    * @return none
    */
    function _select($data) {
        if (empty($data)) return;

        $data = $this->_translateData($data);
        
        $name=$this->_name();$title=$data[0];$data[0]='---';
               
        // sprawdz czy tytul jest zakonczony znakiem '->', jesli tak to jest to definicja atrybutow zaleznych
        if (ereg("->",$title)) {
            $this->_subSelect($data,LangF::translate(trim($title)));            
            return(0);
        }
        
        $data=$this->_activeData($data);
        if ($this->_allow_change_image==true) {
            // sprawdz czy w atrybutach jest jakies wywolanie zdjecia
            if ($this->_isImage($data)) {
                $attrib="onChange=imgChange(this)";
            } else $attrib='';
            if ($this->_change_image==true) $this->_allow_change_image=false;
        } else $attrib='';
        
        $this->forms->addSelect($name,LangF::translate(trim($title)),$data,'',1,'',false,$attrib);
        // zapamietaj powiazanie nazwy opcji z nazwa elementu formularza
        $this->_names[trim($title)]=$name;
                
        return(0);
    } // end _select()
    
    /**
    * Generuj select dla listy zalenej
    *
    * @param array $data tablica z danymi  [0]->nazwa pola [1]..[n]->atrybuty
    *
    * @access private
    * @return none
    */
    function _subSelect($data,$title) {        
        /*
        Dane postaci:
        Array
        (
        [0] => ---
        [1] => L-> czerwony, zielony
        [2] => XL->zolty, czerwony
        )
        Przerabiamy na:
        '"options[attr_2]","L->czerwony,zielony;XL->zolty,czerwony"'
        */
        
        $data = $this->_translateData($data);
        $tab=split("->",$title);
        // nazwa elementu formularza w ktorym wywolujemy funkcje JS
        $name_from=$this->_names[trim($tab[0])];
        // nazwa elementu formularza, w ktorym zmieniamy opcje
        $name_to=$this->_names[trim($tab[1])];
                
        reset($data);$o="onChange='selectChange(this.form,this,";
        foreach ($data as $key=>$val) {
            if ($key==0) {
                $o.='"'.$name_to.'","';
            } else {
                $tab2=preg_split("/\n/",$val,ATTR_MAX_ELEMENTS_NUM);
                foreach ($tab2 as $attr2) {
                    $tab3=split("->",$attr2,2);                    
                    $o.=trim($tab3[0])."->";
                    $tab4=split(",",$tab3[1],ATTR_MAX_ELEMENTS_NUM);
                    foreach ($tab4 as $el) {
                        $el=trim($el);
                        $o.=$el.",";   
                    }
                    $o=substr($o,0,strlen($o)-1);
                    $o.=";";
                }
            }
        }
        $o=substr($o,0,strlen($o)-1);
        $o.="\");'";
                        
        // zmien atrybuty w opcji SELECT
        $this->_setFormsAttrib($name_from,$o);
        
        return(0);
    } // end _subSelect()

    /**
    * Zmien atrybuty w elemencie select
    *
    * @param string $name   nazwa pola
    * @param string $attrib atrybuty
    *
    * @access private
    * @return none
    */
    function _setFormsAttrib($name,$attrib) {        
        reset($this->forms->fields);
        $i=0;
        foreach ($this->forms->fields as $field) {
            if (($field[0]=='select') && ($field[1]==$name)) {
                $this->forms->fields[$i][8]=$attrib;            // dla elementu select 8 parametr to atryb.
            }
            $i++;
        } // end foreach
        return(0);
    } // end _setFormsAttrib()
    
    /**
    * Wyswietl element select z atrybutami - produktami odczytanymi ze wskazanych kategorii
    *
    * @param array $data tablica z danymi [0]->nazwa pola [1]..[n]->atrybuty (idc kategorii)
    *
    * @access private
    * @return none
    */
    function _select_cat($data) {
        global $mdbd;
        
        $this->default='';                           // domyslnie nie zaznaczony jest zaden produkt
        
        $title=$data[0];$entries=array();$entr=array();
        for ($i=1;$i<sizeof($data);$i++) {
            $entr[$i]=$this->_productsFromCat($data[$i]);
        } // end for
        
        reset($entr);
        foreach ($entr as $e) {
            while (list($id,$name) = each($e)) {
                $entries[$id]=$name;
            }
        } // end foreach
        
        $name=$this->_name($id,"basket_cat");
        if (! empty($entries)) {
            $this->forms->addSelect($name,$title,$entries,$this->default);
        }
        
        return(0);
    } // end _select_cat()
    
    /**
    * Odczytaj liste produktow wedlug katergorii IDC: kategoria np. id_23, 23_1, 23_27_1
    *
    * @param  array  $idc_data      dane w postaci IDC: kategoria\n IDC: kategori2 itd.
    * @global string $this->default zapamietaj domyslny element na liscie
    *
    * @access private
    * @return array tablica z nazwami produktow, ktore beda wyswietlone na liscie
    */
    function _productsFromCat($data=array()) {
        global $mdbd;
        global $config;
        
        $tab=split("IDC:",$data,2);
        if (! empty($tab[1])) {
            $idc=trim($tab[1]);
            if (ereg(",",$idc)) {
                $tab2=split(",",$idc,2);
                if (! empty($tab2[0])) {
                    $idc=trim($tab2[0]);
                }
                if (! empty($tab2[1])) {
                    $this->default=trim($tab2[1]);  // user_id produktu domyslnie zaznaczonego
                }
            }
        }
        
        $category=array();
        if (ereg("^id_",$idc)) {
            $idc=ereg_replace("id_","",$idc);
        }
        $category=split("_",$idc,5);
        
        // generuj WHERE do zapytania SQL na podstawie danych kategorii
        $where="1";
        for ($i=1;$i<=sizeof($category);$i++) {
            $c=$i-1;
            if (ereg("^[0-9]+$",$category[$c])) {
                $where.=" AND id_category$i=".$category[$c];
            }
        } // end for
        
        // odczytaj liste produktow z bazy
        $products=$mdbd->select($config->select_main_price_list,"main",$where." AND hidden_price!=1",array(),"LIMIT ".ATTR_MAX_CAT_LIST);
        if (($mdbd->num_rows>0) && (is_array($products))) {
            reset($products);$entries=array(''=>'---');
            $row=0;
            foreach ($products as $product) {
                $price=$this->my_price->price($mdbd->result,$row);
                $entries[$product['id']]=$product['name'].", +".$price;
                $row++;
            }
        } else return array();
        
        return $entries;
    } // end _productsFromCat()
    
    
    /**
    * Wyswietl element checkbox z atrybutami. 
    * Generowanie elementw dla danych postaci:
    * ID: 12,1
    *
    * @param array tablica z danymi [0]->nazwa pola [1]..[n]->atrybuty
    *
    * @access private
    * @return none
    */
    function _checkbox($data) {
        global $config;
                       
        $default=0;
        reset($data);$i=0;
        foreach ($data as $idp) {
            if ($i++>0) {
                $tab=split(":",$idp,2);
                if (! empty($tab[1])) {
                    // sprawdz, ktore atrybuty maja byc domyslnie wybrane
                    $tab2=split(",",trim($tab[1]),2);
                    if (! empty($tab2[0])) {
                        $user_id=trim($tab2[0]);
                        if (trim(@$tab2[1])!="1") {
                            $default=0;
                        } else $default=1;
                    }
                    $main=$this->_getMainInfo($user_id);                   
                    $name=$this->_name($main['id']);
                    $prod_price = $main['price'];
                    if($config->price_type == 'netto') {                        
                        $prod_price = MyPrice::brutto2netto($prod_price, $main['vat']);
                    }
                    $title=" ".$main['name']."</td><td align=right>+<b>".$prod_price."</b>";
                    if (! empty($main['name'])) {
                        $this->forms->addCheckbox($name,$title,$default);
                    }
                }
            } // end if ($i++>0)
        } // end foreach
        
        return(0);
    } // end _checkbox()
    
    /**
    * Odczytaj nazwe produktu wskazanego jako atrybut
    *
    * @param string $user_id identyfikator produktu
    *
    * @access private
    * @return array dane produktu "name"=>"nazwa","price"=>"cena produktu brutto"
    */
    function _getMainInfo($user_id='') {
        global $mdbd;
        global $config;
        
        $m=$mdbd->select($config->select_main_price_list,"main","user_id=?",array($user_id=>"text"),"LIMIT 1");
        if ($config->lang!=$config->base_lang) {
            // zmie nazw produktu, we inne pole okrelajce nazw w danym jzyku
            if(!empty($m[$config->lang . "_name"]))
                $m['name'] = $m[$config->lang . "_name"];
        }                
        $m['price']=$this->my_price->price($mdbd->result);        
        
        return $m;
    } // end _getMainName()
    
    /**
    * Sprawdz czy w danej opcji jest zdjecie
    *
    * @param array &$data tablica z danymi opcji
    *
    * @access private
    * @return bool true - w opcji jest wywolanie zdjecia
    */
    function _isImage(&$data) {
        reset($data);
        foreach ($data as $key=>$val) {
            if ((ereg(".jpg",$val)) || (ereg(".jpg",$val)) ||(ereg(".jpg",$val))) {
                return true;
            }
            if ((ereg(".jpg",$key)) || (ereg(".jpg",$key)) ||(ereg(".jpg",$key))) {
                return true;
            }
        } // end foreach
        
        return false;
    } // end _isImage()
    
    /**
    * 'Aktywuj' dane, odczytaj cene, dodlacz obsluge zmiany zdjecia
    *
    * @param array $dane dane do listy formularza
    *
    * @access private
    * @return array przetworzone dane do listy fomularza
    */
    function _activeData($data) {
        global $DOCUMENT_ROOT;
        global $rec;
        
        $_isImage=$this->_isImage($data);
        
        reset($data);$data2=array();
        foreach ($data as $key=>$val)  {
            
            $val=trim($val);
            // sprawdz, czy zdjecie jest zalaczone do opcji
            $tab=split(",",$val,ATTR_MAX_OPTIONS);
            
            $image='';$price='';
            if (! empty($tab[1])) {
                if ( (eregi(".gif$",$tab[1])) || (eregi(".png$",$tab[1])) || (eregi(".jpg$",$tab[1])) ) {
                    $image=trim($tab[1]);
                } else $price=trim($tab[1]);
            }
            
            if ( (empty($image)) && (! empty($tab[2])) && ((eregi(".png$",$tab[2])) || (eregi(".jpg$",$tab[2])) || (eregi(".gif$",$tab[2])))) $image=trim($tab[2]);
            
            $name=$tab[0];
            
            // zazwalaj zmiane zdjecia tylko na 1 liscie atrybutow
            if ($this->_allow_change_image==true) {
                if ((! empty($image)) && (file_exists("$DOCUMENT_ROOT/photo/$image"))) {
                    $this->_change_image=true;
                    $key="IMG:$name:/photo/$image";
                } elseif ($_isImage) {
                    $key="IMG:$name:/photo/".$rec->data['photo'];
                } else $key=$name;
                if (! empty($price)) {
                    $data2[$key]=$name.", ".$price;
                } else $data2[$key]=$name;
            } else {
                if (! empty($price)) {
                    $data2[$name]=$name.", ".$price;
                } else $data2[$name]=$name;
            }
            
        } // end foreach
        
        // zapamietaj ze w fromularzu jest zmiana ceny
        if (! empty($price)) $this->_set_price=true;
        
        return $data2;
    } // end _activeData()
    
    /**
    * Generuj kolejna nazwe pola formularza dla atrybutu
    *
    * @param string $id   id produktu
    * @param string $name nazwa pola formularza (tablicy parametrow)
    *
    * @access private
    * @return string nazwa pola formularza
    */
    function _name($id='',$name='') {
        if (! empty($id)) {
            return "basket[$id]";
        } elseif (! empty($name)) {
            return $name."[attr_".$this->_num++."]";
        } else
        return "options[attr_".$this->_num++."]";
    } // end _name()
    
    /**
    * Sprawdz, czy w opcjach sa zmieniane zdjecia
    *
    * @access public
    * @return bool true - zdjecia sa zmieniane, false w p.w.
    */
    function checkChangeImage() {        
        if ($this->_change_image==false) return false;
        return $this->_change_image;
    } // end checkChangeImage
    
    /**
    * Odczytaj wartosc parametru przekaywana do koszyka
    *
    * @param string $name np. IMG:wartosc:test.jpg
    *
    * @access public
    * return string wartosc atrybutu
    */
    function getName($name) {
        if (ereg("---",$name)) return '';
        
        if (ereg("^IMG:",$name)) {
            $tab=split(":",$name,3);
            if (! empty($tab[1])) return $tab[1];
            else return $name;
        }
        return $name;
    } // end getName()
    
    /**
    * Wyswietl cen eproduktu wg atrybutow (cena zmieniana online)
    *
    * @param float $price domyslna cena
    *
    * @access public
    * @return none
    */
    function showPrice($price) {
        print "<form name=price><input type=text readonly name=price_preview value='$price' class=text_preview size=12></form>\n";
        return(0);
    } // end showPrice()
    
    
    /**
    * Odczytaj cene produktow wg podanych atrybutow
    *
    * @param  float   $price_brutto cena produktu brutto
    * @param  string &$xml_options  wartosc pola xml_options produktu
    * @global object &$this->result wynik zapytania z bazy danych (o dane produktu)
    *
    * @access public
    * @return float cena sprzedazy produktu
    */
    function price($price_brutto,&$xml_options) {
        global $db;
        global $_REQUEST;
        
        if (empty($xml_options)) {
            return $price_brutto;
        }
        
        if (! empty($_REQUEST['options'])) {
            if (is_array($_REQUEST['options'])) {
                $options=$_REQUEST['options'];
            } else return $price_brutto;
        }
        
        reset($options);
        if (empty($this->_price_brutto)) {
            $this->_price_brutto=$price_brutto;
        }
        foreach ($options as $key=>$val) {
            if (ereg("^attr_",$key)) {
                
                // odczytaj numer grupy parametrow
                preg_match("/^attr_([0-9]+)$/",$key,$matches);
                if (! empty($matches[1])) {
                    $num=$matches[1];
                } else continue;
                
                $attrib=$this->getName($_REQUEST['options'][$key]);
                if (empty($attrib)) continue;
                
                $data=preg_split("/\n/",$xml_options);$num_param=0;
                // $data zawiera w tablicy linie calej wartosci xml_options
                foreach ($data as $line) {
                    $line=trim($line);
                    if ($num_param==$num) {
                        $tab=split(",",$line,3);
                        if (LangF::translate(@$tab[0])==trim($attrib)) {
                            if (ereg("^[-0-9+. ]+$",trim(@$tab[1]))) {
                                $nprice=trim($tab[1]);  $nprice=ereg_replace(" ","",$nprice);                            
                                $subprice=number_format(substr($nprice,1,strlen($nprice)-1),2,'.','');  
                                if (substr($nprice,0,1)=="+") {
                                    $this->_price_brutto+=$subprice;
                                } elseif (substr($nprice,0,1)=="-") {
                                    $this->_price_brutto-=$subprice;
                                } else {
                                    $this->_price_brutto=$nprice;
                                }
                            }
                        } // if (@$tab[0]==attrib)
                    }
                    if (empty($line)) {
                        $num_param++;
                    }
                } // end foreach lines
            } // if (ereg("^attr",$key))
        } // end foreach
        
        if ($this->_price_brutto<0) $this->_price_brutto=0;
        
        return $this->_price_brutto;
    } // end price()
    
    /**
    * Sprawdz czy dany typ danych mozna edytowac w formie uproszczonej (wprowadzajac dane do pola <input ...>
    *
    * @access public
    * @return boll   true - uproszczona edycja jest dostepna, false w p.w.
    */
    function checkSimpleEdit() {
        return false;
    } // end checkSimpleEdit()
    
} // end class MultiGroup

class MyXMLOptions extends MultiGroup {};
$my_xml_options = new MyXMLOptions;

?>
