<?php
/**
* Obliczenie kosztow dostawy. Wywietlanie informacji o dostawie.
* Klasa zawiera funkcje obliczajce warto dostawy na podstawia wartoci zmwienia, oraz prezentacj
* listy dostawcw wraz z kosztami dostawy.
*
* @author  m@sote.pl
* @version $Id: delivery.inc.php,v 2.8 2004/07/12 09:27:32 krzys Exp $
* @package basket
* @subpackage delivery
*/

/**
* Dostawa towaru.
* @package basket
* @subpackage delivery
*/
class Delivery {
    var $checked=false;
    var $data=array();      // dane dostawcy, informacja o wybranym dostawcy
    var $delivery_id=-1;    // id wybranego dostawcy
    var $delivery_name="";  // nazwa jw.
    var $delivery_cost=0;   // koszt dostawy
    
    /**
    * Oblicz koszty dostawy, odczytaj dane z bazy i zpamitaj w tabclicy.
    *
    * @return none
    */
    function calc() {
        global $theme,$lang;
        global $db;
        global $_SESSION;
        global $shop;
        global $basket;
        
        // odczytaj wartoc zamwienia
        $basket->calc();
        $global_basket_amount=$basket->amount;              
        
        // zanim odczytasz nazwe dostawcy, domyslnie jest on nieokreslony
        // wymagadne w przypadku, kiedy nie ma zadnego dostawcy w bazie
        $this->delivery_name=$lang->basket_delivery_name_unknown;
        
        $query="SELECT * FROM delivery ORDER BY order_by";
        $result=$db->Query($query);
        if ($result!=0) {
            $num_rows=$db->NumberOfRows($result);
            if ($num_rows==0) {
                return;
            } else {
                for ($i=0;$i<$num_rows;$i++) {
                    $this->id=$db->FetchResult($result,$i,"id");
                    $this->name=$db->FetchResult($result,$i,"name");
                    $this->price_brutto=$db->FetchResult($result,$i,"price_brutto");
                    $this->vat=$db->FetchResult($result,$i,"vat");
                    $this->free_from=$db->FetchResult($result,$i,"free_from");
                    $this->delivery_info=$db->FetchResult($result,$i,"delivery_info");
                    
                    if ($global_basket_amount>=$this->free_from) {
                        $this->cost=0;
                    } else {
                        $this->cost=$theme->price($this->price_brutto);
                    }
                    $this->_calc_row();
                }
            }
        }
        
        return;
    } // end show()
    
    /**
    * Zapamietaj dane dostawcy. Zaznacz wybranego dostawc.
    *
    * \@global int $_REQUEST['delivery'] ID dostawcy (pole id z tabeli delivery)
    * @access private
    * @return none
    */
    function _calc_row() {
        global $lang;
        global $config;
        global $_REQUEST;
        
        $checked=false;;
        if (empty($_REQUEST['delivery'])) {
            // ustaw domyslnego dostawce - pierwszego z listy dostawcow
            if ($this->checked==false) {
                $this->save_delivery();
                $checked=true;
            }
        } else {
            // jest juz w sesji wybrany dostawca - zmiana dostawcy
            if ($_REQUEST['delivery']['id']==$this->id) {
                $this->save_delivery();
                $checked=true;
            }
        }
        if  (! empty($checked)) $this->checked=true;
        
        // zapamietaj dane dostawcy (kolejnych dostawcw)
        $tab=array();
        $tab['id']=$this->id;
        $tab['name']=$this->name;
        $tab['cost']=$this->cost;
        $tab['checked']=$checked;
        $tab['delivery_info']=$this->delivery_info;
        
        // start dodaj tlumaczenie:
        if ($config->base_lang!=$config->lang) {
            $tab['name']=LangFunctions::f_translate($this->name);
            $tab['delivery_info']=LangFunctions::f_translate($this->delivery_info);
        }
        // end dodaj tlumaczenie:
        
        array_push($this->data,$tab);
        
        return;
    } // end _calc_row()
    
    /**
    * Zapamietaj dane wybranego dostawcy
    */
    function save_delivery() {
        global $sess;
        
        $this->delivery_id=$this->id;
        $this->delivery_name=$this->name;
        $this->delivery_cost=$this->cost;
        
        return;
    } // end save_delivery()
    
    /**
    * Prezentacja kosztow dostawy
    */
    function show() {
        print "<p>\n";
        print "<table  border=\"0\">\n";
        foreach ($this->data as $data) {
            $this->id=$data['id'];
            $this->name=$data['name'];
            $this->cost=$data['cost'];
            $this->delivery_info=$data['delivery_info'];
            if ($data['checked']==true) $this->checked=" checked";
            else $this->checked="";
            
            $this->_row();
        }
        print "</table>\n";
        return;
    } // end show()
    
    /**
    * Prezentacja 1 dostawcy
    *
    * @access private
    * @return none
    */
    function _row() {
        global $config,$lang;
        global $shop; 
        
        if (! empty ($this->delivery_info)) $dinfo_sep=",";
        else $dinfo_sep="";
              
        
        $price=$shop->currency->price($this->cost);
        $price.=" ".$shop->currency->currency."</nobr>";
        print "  <tr>";
        print "    <td valign=\"top\">\n";
        print "      <input type=\"radio\" name=\"delivery[id]\" $this->checked value=\"$this->id\" onclick=\"this.form.submit();\" class=\"border0\">";
        print "      <input type=\"hidden\" name=\"delivery[name]\" value=\"$this->name\"</td>\n";
        print "    <td valign=\"top\">$this->name,</td><td valign=top>$lang->basket_delivery_cost</td>\n";
        print "    <td valign=\"top\">".$price."$dinfo_sep</td>\n";
        print "    <td valign=\"top\">$this->delivery_info</td>\n";
        print "  </tr>\n";
    } // end _row()
    
} // end class Delivery

$delivery_obj =& new Delivery;

?>
