<?php
/**
* Klasa z funkcjami do formularza VAT
*
* @author rp@sote.pl
*
* @version $Id: vat_functions.php,v 1.1 2004/06/12 11:29:40 krzys Exp $
* @package soteesklep
*/
class VAT{
    
    /**
    * @desc generuje puste pola do wypelnienia w formularzu w przypadku nie zalogowania uzytkownika
    *
    * @return void
    */
    function address_firm_dots(){
        global $lang;
        
        print "<table>\n";
        print "  <tr>\n";
        print "    <td align=\"left\" style=\"padding: 24px 24px; line-height: 30px;\">\n";
        $dots ="Nazwa firmy ............................................................<br/ >\n";
        $dots.="Adres firmy .............................................................<br/ >\n";
        $dots.="Numer Identyfikacji Podatkowej .....................................<br/ >\n";
        print $dots;
        print "</td>\n";
        print "  </tr>\n";
        print "</table>\n";
        
        return;
    } // end address_firm_dots()
    
    /**
    * @desc wyswietla dane zarejestrowanego uzytkownika
    *
    * @return void
    */
    function address_firm(){
        global $lang;
        
        print "<table>\n";
        if(!empty($this->address['firm'])){
            print "  <tr>\n";
            print "    <td align=\"right\">Firma:&nbsp;<td>\n";
            print "    <td align=\"left\">\n";
            print "<h4>".$this->address['firm']."</h4>";
            print "</td>\n";
            print "  </tr>\n";
        }
        if(!empty($this->address['name'])){
            print "  <tr>\n";
            print "    <td align=\"right\">Imie:&nbsp;<td>\n";
            print "    <td align=\"left\">\n";
            print "<b>".$this->address['name']."</b>";
            print "</td>\n";
            print "  </tr>\n";
        }
        if(!empty($this->address['surname'])){
            print "  <tr>\n";
            print "    <td align=\"right\">Nazwisko&nbsp;<td>\n";
            print "    <td align=\"left\">\n";
            print "<b>".$this->address['surname']."</b>";
            print "</td>\n";
            print "  </tr>\n";
        }
        if(!empty($this->address['street'])){
            print "  <tr>\n";
            print "    <td align=\"right\">Adres:&nbsp;<td>\n";
            print "    <td align=\"left\">\n";
            print "<b>".$this->address['street']."</b>";
            print "&nbsp;";
            print "<b>".$this->address['street_n1']."</b>";
             print "/";
             if(!empty($this->address['street_n2'])){
                 print "<b>".$this->address['street_n2']."</b>";
             }
             print "</td>\n";
             print "  </tr>\n";
        }
        if(!empty($this->address['postcode'])){
            print "  <tr>\n";
            print "    <td align=\"right\">Miejscowo:&nbsp;<td>\n";
            print "    <td align=\"left\">\n";
            print "<b>".$this->address['postcode']."</b>";
            print "&nbsp;";
            if(!empty($this->address['city'])){
                print "<b>".$this->address['city']."</b>";
            }               
            print "</td>\n";
            print "  </tr>\n";
        }
        print "</table>\n";   
        
        return;     
    } // end address_firm()

    /**
    * @desc wyswietla dzisiejsza date    
    *
    * @return void
    */
    function today(){
        $day=date("j");
        $month=date("n");
        $year=date("Y");
        
        $month_name=array(
            "Stycze",
            "Luty",
            "Marzec",
            "Kwiecie",
            "Maj",
            "Czerwiec",
            "Lipiec",
            "Sierpie",
            "Wrzesie",
            "Padziernik",
            "Listopad",
            "Grudzie"
        );
        print $day." ".$month_name[$month]." ".$year;
        
        return;
    } // end today()

    /**
    * @desc wyswietla adres wlasciciela sklepu z pliku lang
    *
    * @global object $lang definicje jezykowe
    *    
    * @return void
    */
    function address(){       
        global $lang;
                 
        print "<table>\n";
        print " <tr>\n";
        print "   <td><h5>\n";
        print $lang->vat_address['firm']."<br />\n";
        print $lang->vat_address['street']."&nbsp;";
        print $lang->vat_address['street_n1'];
        if(!empty($lang->vat_address['street_n2'])){        
            print "/".$lang->vat_address['street_n2']."<br />\n";
        } else {
            print "<br />\n";
        }
        print $lang->vat_address['post_code']."&nbsp;";
        print $lang->vat_address['city']."<br />\n";
        print $lang->vat_address['nip']."<br />\n";
        print "</h5></td>\n";
        print " </tr>\n";
        print "</table>\n";
        
        return;
    } // end address()
    
    /**
    * @desc sprawdza czy sa dane bilingowe zapisane w sesji i na ich podstawie generuje upowazenienie
    *
    * @global object $_SESSION
    * @param  array  $_SESSION['form']
    *
    * @return bool false | true - jesli adres jest w sesji
    */
    function address_data(){
        global $_SESSION;
        
        if(!empty($_SESSION['form'])){            
            $this->address=$_SESSION['form'];
            return true;
        }
        
        return false;
    } // end vat_data()

} // end class VAT
$vat=new VAT;
?>