<?php
/**
* Obsuga buttonw. Wyswietlanie menu buttonw itp.
*
* @author m@sote.pl rp@sote.pl
* @version $Id: buttons.inc.php,v 2.11 2004/06/06 08:47:49 maroslaw Exp $
* @package themes
* @subpackage buttons
*/

/**
* Buttony
* @package themes
* @subpackage buttons
*/
class Buttons {
    /**
    * Sciezka do obrazkow.
    * @deprecated since 3.0
    */
    var $img_dir="_img/_layout_buttons";
    
    /**
    * Sprawdz czy obecny wywolany aders odpowiada adersowi zdefiniowanemu dla danego buttona
    *
    * @param  string $url link przypisany do buttona
    * @return bool   true - dany butto jest wywolany; false wpw.
    */
    function check_button($url,$name='') {
        global $_SERVER;
        
        if ($name=="<<") return false;
        
        $REQUEST_URI=$_SERVER['REQUEST_URI'];
        preg_match("/([a-zA-Z_\/0-9-.]+)/",$REQUEST_URI,$matches);
        preg_match("/([a-zA-Z_\/0-9-.]+)/",$url,$matches_url);
        $current_url=$matches[1];
        if (! empty($matches_url[1])) {
            $url=$matches_url[1];
        }
        
        // sprawdz linki postaci href=index.php href=search.php - odwolania wzgledne
        if (! ereg("/",$url)) {
            if ((ereg("$url$",$current_url)) && (! empty($url)))
            return true;
            if (($url=="index.php") && (! ereg("php$",$current_url))) return true;
        }
        
        // sprawdz linki bez index.php
        // print "<nobr>current_url=$current_url url=$url&nbsp</nobr><BR>";
        if ($current_url."/index.php"==$url) {
            return true;
        }
        
        
        if ($url==$current_url) return true;
        else return false;
    } // end check_button()
    
    /**
    * Funckja generuje dynamicznie przyciski (menu)+ linki
    *
    * @param array $buttons np. array("nazwa1"=>"link1","nazwa2"=>"link2")
    */
    function menu_buttons($buttons,$level=1) {
        // sprawdz liczbe przyciskow
        $num=sizeof($buttons);
        
        // wez 1 klucz+wartosc z tablicy $buttons
        reset($buttons);
        $name=key($buttons);$url=$buttons[$name];
        print "\n";
        print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
        print "  <tr>\n";
        if ($num <= 1) {
            // jesli jest 1 przycisk, to wyswietl wszystkie boki
            print "    <td>\n";
            $this->button_left($name,$url);
            print "</td>\n";
        } else {
            $i=0;
            print "    <td>\n";
            $this->button_left($name,$url);
            print "</td>\n";
            $first=false;
            while (list ($name,$url) = each($buttons)) {
                if ($first==true) {
                    print "    <td>\n";
                    $this->button_right($name,$url);
                    print "</td>\n";
                } else $first=true;
            }
        }
        print "    <td>&nbsp;&nbsp;</td>\n";
        if ($level>1) {
            $i=1;
            while ($i<2) {
                print "    <td>&nbsp;&nbsp;</td>\n";
                $i++;
            }
        }
        print "  </tr>\n";
        print "</table>\n";
        
        return;
    } // end buttons()
    
    /**
    * Wyswietl 1 pelny przycisk
    *
    * @param string $name tekst na przycisku
    * @param string $url link
    */
    function button_left($name,$url) {
        global $theme;
        global $config;
        
        // jesli $url jest linkiem wzglednym lokalnym, to nie dodawaj prefixu
        if (! ereg("/",$url)) {
            $url_prefix="";
        } else $url_prefix=$config->url_prefix;
        
        if (! $this->check_button($url,$name)) {
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
            print "  <tr>\n";
            print "    <td><img src=\"";
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['left']);
            // $theme->bmp("bln1","layout_buttons");
            print "\" alt=\"\">";
            print "</td>\n";
            print "    <td background=\"";
            // $theme->bmp("bcn1","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['center']);
            print "\" nowrap>&nbsp;<a href=\"$url_prefix"."$url\" class=\"buttons\">$name</a>&nbsp;";
            print "</td>\n";
            print "    <td><img src=\"";
            // $theme->bmp("brn1","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['right']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        } else {
            
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
            print "  <tr>\n";
            print "    <td><img src=\"";
            $theme->bmp("bln1_a","layout_buttons");
            // $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['left']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "    <td background=\"";
            $theme->bmp("bcn1_a","layout_buttons");
            // $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['center']);
            print "\" nowrap>&nbsp;<a href=\"$url_prefix"."$url\" class=\"buttons\">$name</a>&nbsp;";
            print "</td>\n";
            print "    <td><img src=\"";
            $theme->bmp("brn1_a","layout_buttons");
            // $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['right']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        }
        
        return;
    } // end button_left()
    
    /**
    * Wyswietl przycisk bez lewej krawedzi
    *
    * @param string $name tekst na przycisku
    * @param string $url link
    */
    function button_right($name,$url) {
        global $theme;
        global $config;
        
        // jesli $url jest linkiem wzglednym lokalnym, to nie dodawaj prefixu
        if (! ereg("/",$url)) {
            $url_prefix="";
        } else $url_prefix=$config->url_prefix;
        
        // nazewnictwo bitmap: bln - button left normal, bcn - button central (back) normal
        if (! $this->check_button($url,$name)) {
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
            print "  <tr>\n";
            print "    <td>";
            print "<img src=\"";
            // $theme->bmp("bln2","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['left']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "    <td background=\"";
            // $theme->bmp("bcn2","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['center']);
            print "\" nowrap>&nbsp;<a href=\"$url_prefix"."$url\" class=\"buttons\">$name</a>&nbsp;";
            print "</td>\n";
            print "    <td>";
            print "<img src=\"";
            // $theme->bmp("brn2","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['right']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        } else {
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
            print "  <tr>\n";
            print "    <td>";
            print "<img src=\"";
            $theme->bmp("bln2_a","layout_buttons");
            print "\" alt=\"\">";
            print "</td>\n";
            print "    <td background=\"";
            $theme->bmp("bcn2_a","layout_buttons");
            print "\" nowrap>&nbsp;<a href=\"$url_prefix"."$url\" class=\"buttons\">$name</a>&nbsp;";
            print "</td>\n";
            print "    <td>";
            print "<img src=\"";
            $theme->bmp("brn2_a","layout_buttons");
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        }
    } // end button_right()
    
    
    /**
    * Wyswietl 1 pelny "samodzielny" przycisk z tekstem
    *
    * @param string $name tekst na przycisku
    * @param string $url link
    */
    function button($name,$url) {
        global $theme;
        global $config;
        
        // jesli $url jest linkiem wzglednym lokalnym, to nie dodawaj prefixu
        if (! ereg("/",$url)) {
            $url_prefix="";
        } else $url_prefix=$config->url_prefix;
        
        if (! $this->check_button($url,$name)) {
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
            print "  <tr>\n";
            print "    <td><img src=\"";
            // $theme->bmp("bln1","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['left']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "    <td background=\"";
            // $theme->bmp("bcn1","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['center']);
            print "\" nowrap>&nbsp;<a href=$url_prefix"."$url>$name</a>&nbsp;";
            print "</td>\n";
            print "    <td><img src=\"";
            // $theme->bmp("brn1","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['right']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        } else {
            print "\n";
            print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">\n";
            print "  <tr>\n";
            print "    <td>";
            print "<img src=\"";
            // $theme->bmp("bln1_a","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['left']);
            print "\" alt=\"\"></TD>\n";
            print "    <td background=\"";
            // $theme->bmp("bcn1_a","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['center']);
            print "\" nowrap>&nbsp;<a href=$url_prefix"."$url>$name</a>&nbsp;";
            print "</td>\n";
            print "    <td>";
            print "<img src=\"";
            // $theme->bmp("brn1_a","layout_buttons");
            $theme->path("_img/_bmp/" . $config->theme_config['head']['small_menu']['img']['right']);
            print "\" alt=\"\">";
            print "</td>\n";
            print "  </tr>\n";
            print "</table>\n";
        }
        return;
    } // end button_left()
} // end class Buttons
?>