<?php
/**
 * Sprawdz poprawnosc formularza, dodatkowe funkcje
 *
 * @author  pmalinski@sote.pl
 * @template_version Id: form_check_functions.inc.php,v 2.3 2003/06/14 21:59:37 maroslaw Exp
 * @version $Id: form_check_functions.inc.php,v 1.3 2003/09/01 10:22:46 piotrek Exp $
 * @package soteesklep
 * @return  int $this->id
 */
require_once("include/metabase.inc");

class FormCheckFunctions extends FormCheck {
    // lokalne definicja fukcji sptrawdzajacych poprawnosc pol formularza
    
    /**
     * Sprawdz czy pole jest typu procentowego 0-100% - zezwol na wpisywanie wartosci ponizej jednego procenta
     *
     * @param string $val wartosc pola
     * @return bool true - poprawnie wypelnione pole, false - bledna wartosc
     */
    function percentage($val) {
        if (ereg("^[0-9.]+$",$val)) 
            if (($val>=0) && ($val<=100)) 
                return true;
        return false;
    }
    
    /**
     * Sprawdz czy pole jest wypelnione zgodnie z obowiazujacym formatem email
     *
     * @param string $val wartosc pola
     * @return bool true - poprawnie wypelnione pole, false - bledna wartosc
     */
    function email($val) {
        
        if ((eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$val)) || (empty($val))) 
            return true;
        return false;
    }

    /**
     * Sprawdz czy pole zawiera osiem cyfr i czy taki identyfikator istnieje w bazie
     *
     * @param string $val wartosc pola
     * @return bool true - poprawnie wypelnione pole, false - bledna wartosc
     */
    function partner_id($val) {
        global $database;

        if (eregi("^[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$",$val)) {
            $check=$database->sql_select("id","partners","partner_id=$val");
            if(! empty($check)) return false; 
            return true;
        }
        return false;
    }

    
} // end class FormCheckFunctions
?>