<?php
/**
 * Testowanie opcji PHP
 *
 * @author  m@sote.pl
 * @version $Id: test_php.inc.php,v 2.4 2004/03/16 16:28:44 maroslaw Exp $
 * @soteesklep
 */
 
class TestPHP {
    var $version="431"; // wymagana wersja m.in. PHP-4.1.2
    var $version_print=">=4.3.1";
    var $installed="Yes:)";
    var $not_onstalled="No:(";
    var $next="Next";
    var $num=1;
    var $testall=true;

    /**
     * Rozpocznij testy opcji PHP
     *
     * @global bool $this->testall true wszystko OK
     *
     * return none 
     */
    function test_start() {
        print "<table align=center>\n";
        $this->test("PHP: ($this->version_print): ",$this->version());
        $this->test("PHP: MySQL",$this->mysql());
        $this->test("PHP: ftp",$this->ftp());
        $this->test("PHP: trans_sid",$this->trans_sid());
        print "</table>\n";
        return;
    } // end test_start()

    /**
    * Wywietl informacje o tym, czy dana opcja jest zainstalowana
    *
    * @param string $text nazwa/opis opjcji
    * @param bool   true  opcja jest zainstalowana/skonfigurowana
    * 
    * @return none
    */
    function test($text,$bool) {
        global $lang;

        print "<tr><td>$this->num. $text</td><td>";
        if ($bool) print "<b>".$this->installed."</b>";
        else print "<b>".$this->not_installed."</b>";
        print "</td></tr>";
        $this->num++;

        if (! $bool) $this->testall=false;

        return;
    } // end test()

    /**
    * Weryfikuj wersje PHP
    *
    * @return bool true - wersja OK, false w p.w.
    */
    function version() {
        $php_version=phpversion();
        $php_version=number_format(ereg_replace("\.","",$php_version));
        if ($php_version>=$this->version) return true;
        return false;
    } // end version

    /**
    * Sprawd, czy PHP zawiera obsuge MySQL
    *
    * @return bool true PHP zawiera obsuge MySQL, false w p.w.
    */
    function mysql() {
        if (function_exists('mysql_connect')) return true;
        else return false;
    } // end mysql()

    /**
    * Sprawd, czy PHP zawiera obsuge FTP (--enable-ftp)
    *    
    * @return bool true PHP zawiera obsuge FTP, false w p.
    */
    function ftp() {
        if (function_exists('ftp_login')) return true;
        else return false;
    } // end ftp()

    /**
    * Sprawd, czy PHP ma wczon opcj transparentnych sesji
    *
    * @return bool true PHP zawiera obsuge transparentnych sesji, false w p.
    */
    function trans_sid() {
        $trans_sid=ini_get("session.use_trans_sid");
        if ($trans_sid==1) return true;
        else return false;
    } // end ftp()

} // end class TestPHP

$test_php =& new TestPHP;

$test_php->installed=$lang->installed;
$test_php->not_installed=$lang->not_installed;
$test_php->next=$lang->next;

?>
